<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: ehrhart_lower_bound.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>ehrhart_lower_bound.c</h1><a href="ehrhart__lower__bound_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00020"></a>00020 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a><a class="code" href="ehrhart__lower__bound_8c.html#a3c04138a5bfe5d72780bb7e82a18e627">00025</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a>( <span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> **argv)
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027   <span class="keywordtype">int</span> i;
<a name="l00028"></a>00028   <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name;
<a name="l00029"></a>00029   <a class="code" href="structmatrix.html">Matrix</a> *C1, *P1;
<a name="l00030"></a>00030   <a class="code" href="structpolyhedron.html">Polyhedron</a> *P, *C;
<a name="l00031"></a>00031   <a class="code" href="struct__enumeration.html">Enumeration</a> *e, *en;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <a class="code" href="structmatrix.html">Matrix</a> * Validity_Lattice;
<a name="l00034"></a>00034   <span class="keywordtype">int</span> nb_parms;
<a name="l00035"></a>00035   
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>  Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, *tmp;
<a name="l00038"></a>00038   <span class="keywordtype">int</span> k;
<a name="l00039"></a>00039 <span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041   P1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00042"></a>00042   C1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00043"></a>00043   nb_parms = C1-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-2;
<a name="l00044"></a>00044   <span class="keywordflow">if</span>(nb_parms &lt; 0) {
<a name="l00045"></a>00045     fprintf( stderr, <span class="stringliteral">&quot;Not enough parameters !\n&quot;</span> );
<a name="l00046"></a>00046     exit(0);
<a name="l00047"></a>00047   }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049    <span class="comment">/* Read the name of the parameters */</span>
<a name="l00050"></a>00050   param_name = <a class="code" href="param_8c.html#ac5f556f34173ebc8815247ee7f4e2a0b">Read_ParamNames</a>(stdin,nb_parms);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">/* inflate the polyhedron, so that the inflated EP approximation will be an</span>
<a name="l00053"></a>00053 <span class="comment">     upper bound for the EP&apos;s polyhedron. */</span>
<a name="l00054"></a>00054   <a class="code" href="matrix__addon_8c.html#a0f0ba73176f5316a02e849b8c210204a" title="deflates a polyhedron (represented as a matrix) P, so that the apx of its Ehrhart...">mpolyhedron_deflate</a>(P1,nb_parms);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* compute a polynomial approximation of the Ehrhart polynomial */</span>
<a name="l00057"></a>00057   e = <a class="code" href="ehrhart_8c.html#a0d3e40195e67384f3655c772212ed1d5" title="Computes the approximation of the Ehrhart polynomial of a polyhedron (implicit form...">Ehrhart_Quick_Apx</a>(P1, C1, &amp;Validity_Lattice, 1024);
<a name="l00058"></a>00058   
<a name="l00059"></a>00059   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C1);
<a name="l00060"></a>00060   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(P1);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   printf(<span class="stringliteral">&quot;============ Ehrhart polynomial quick polynomial lower bound ============\n&quot;</span>);
<a name="l00063"></a>00063   <a class="code" href="matrix__addon_8h.html#a11468159c7fa7d75fadfa10e2e929fee" title="Polylib matrix addons Mainly, deals with polyhedra represented in implicit form (set...">show_matrix</a>(Validity_Lattice);
<a name="l00064"></a>00064   <span class="keywordflow">for</span>( en=e ; en ; en=en-&gt;<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a> ) {    
<a name="l00065"></a>00065     <a class="code" href="polyparam_8c.html#afa315bc856959f9a781359f69b74d7a4">Print_Domain</a>(stdout,en-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>, param_name);
<a name="l00066"></a>00066     <a class="code" href="ehrhart_8c.html#a99718adf05e065181f35f5ca847f94b0">print_evalue</a>(stdout,&amp;en-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>, param_name);
<a name="l00067"></a>00067     printf( <span class="stringliteral">&quot;\n-----------------------------------\n&quot;</span> );
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069  
<a name="l00070"></a>00070 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>  <span class="keywordflow">if</span>( isatty(0) &amp;&amp; nb_parms != 0)
<a name="l00072"></a>00072   {  <span class="comment">/* no tty input or no polyhedron -&gt; no evaluation. */</span>
<a name="l00073"></a>00073     printf(<span class="stringliteral">&quot;Evaluation of the Ehrhart polynomial :\n&quot;</span>);
<a name="l00074"></a>00074     p = (Value *)malloc(<span class="keyword">sizeof</span>(Value) * (nb_parms));
<a name="l00075"></a>00075     <span class="keywordflow">for</span>(i=0;i&lt;nb_parms;i++) 
<a name="l00076"></a>00076       <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(p[i]);
<a name="l00077"></a>00077     <a class="code" href="types_8h.html#a75c828ed6c02fcd44084e67a032e422c">FOREVER</a> {
<a name="l00078"></a>00078       fflush(stdin);
<a name="l00079"></a>00079       printf(<span class="stringliteral">&quot;Enter %d parameters : &quot;</span>,nb_parms);
<a name="l00080"></a>00080       <span class="keywordflow">for</span>(k=0;k&lt;nb_parms;++k) {
<a name="l00081"></a>00081         scanf(<span class="stringliteral">&quot;%s&quot;</span>,str);
<a name="l00082"></a>00082         <a class="code" href="source_2arith_2arithmetique_8h.html#ab8a77ddf3765fd598f31d8ca2ac4705c">value_read</a>(p[k],str);
<a name="l00083"></a>00083       }
<a name="l00084"></a>00084       fprintf(stdout,<span class="stringliteral">&quot;EP( &quot;</span>);
<a name="l00085"></a>00085       <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[0]);
<a name="l00086"></a>00086       <span class="keywordflow">for</span>(k=1;k&lt;nb_parms;++k) {
<a name="l00087"></a>00087         fprintf(stdout,<span class="stringliteral">&quot;,&quot;</span>);
<a name="l00088"></a>00088         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[k]);
<a name="l00089"></a>00089       }
<a name="l00090"></a>00090       fprintf(stdout,<span class="stringliteral">&quot; ) = &quot;</span>);
<a name="l00091"></a>00091       <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,*(tmp=<a class="code" href="eval__ehrhart_8c.html#af970e7f69cbf548188a8f3754001a150">compute_poly</a>(en,p)));
<a name="l00092"></a>00092       free(tmp);
<a name="l00093"></a>00093       fprintf(stdout,<span class="stringliteral">&quot;\n&quot;</span>);  
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096 <span class="preprocessor">#endif </span><span class="comment">/* EP_EVALUATION */</span>
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="keywordflow">while</span>( e )
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       <a class="code" href="ehrhart_8c.html#a96434ed8279f7999773fa3343cfe98b8" title="releases all memory referenced by e.">free_evalue_refs</a>( &amp;(e-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>) );
<a name="l00101"></a>00101       <a class="code" href="polyhedron_8c.html#a4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>( e-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a> );
<a name="l00102"></a>00102       en = e -&gt;<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a>;
<a name="l00103"></a>00103       free( e );
<a name="l00104"></a>00104       e = en;
<a name="l00105"></a>00105     }
<a name="l00106"></a>00106   <a class="code" href="param_8c.html#ae85c395031b2feb7cc47ba691bb6392f">Free_ParamNames</a>(param_name, nb_parms);
<a name="l00107"></a>00107   <span class="keywordflow">return</span> 0;
<a name="l00108"></a>00108 }
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:25 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
